#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>

#define PERIODOS 6

float* le_vetor() {
    int p;
    float* v;
    v = (float*) malloc(sizeof(float)*(float)PERIODOS);
    for(p=0;p<(int)PERIODOS;p++)
        scanf("%f", &(v[p]));
    return v;
}

void imprime_vetor(float *v) {
    int p;
    for(p=0;p<(int)PERIODOS;p++)
        printf("%f ", v[p]);
    printf("\n");
}

float soma_vetor(float *v) {
    int p;
    float soma;
    soma = 0.0;
    for(p=0;p<(int)PERIODOS;p++)
        soma += v[p];
    return soma;
}

float* calcula_fits(float *fitsReal,
                    float minPenalidade, float penalidade, float peso) {
    int p;
    float *fits;
    fits = (float*) malloc(sizeof(float)*(float)PERIODOS);
    for(p=0;p<(int)PERIODOS;p++)
        if (fitsReal[p] > minPenalidade)
            fits[p] = (pow((fitsReal[p]+1.0), penalidade)) * peso;
        else
            fits[p] = fitsReal[p] * peso;
    return fits;
}

int main(int argc, char const *argv[]) {
    float *fitsRealEnergia, *fitsRealVolume;
    float *fitsEnergia, *fitsVolume;

    fitsRealEnergia = le_vetor();
    fitsRealVolume = le_vetor();

    // minPenalidade, penalidade, peso
    fitsEnergia = calcula_fits(fitsRealEnergia, 0.1, 2.0, 0.7);
    fitsVolume = calcula_fits(fitsRealVolume, 0.5, 2.0, 0.3);

    printf("ENERGIA:\n");
    imprime_vetor(fitsRealEnergia);
    printf("%f\n", soma_vetor(fitsRealEnergia));
    imprime_vetor(fitsEnergia);
    printf("%f\n", soma_vetor(fitsEnergia));

    printf("VOLUME:\n");
    imprime_vetor(fitsRealVolume);
    printf("%f\n", soma_vetor(fitsRealVolume));
    imprime_vetor(fitsVolume);
    printf("%f\n", soma_vetor(fitsVolume));

    printf("FITNESS:\n");
    printf("%f\n", soma_vetor(fitsRealEnergia)+soma_vetor(fitsRealVolume));
    printf("%f\n", soma_vetor(fitsEnergia)+soma_vetor(fitsVolume));

    free(fitsRealVolume);
    free(fitsVolume);
    free(fitsRealEnergia);
    free(fitsEnergia);

    return 0;
}
